package LF::Sentence::LogicForm;

use Data::Dumper;

use Class::MethodMaker
  new_with_init => 'new',
  get_set       => [

qw / Predicate Function Args /

];

sub init {
  my ($self,%args) = @_;
  $self->Args([]);
}

sub Print {
  my ($self,%args) = @_;
  # $self->DebugArgs;
  return $self->Predicate.
    #(defined $self->Function ? ":".$self->Function : "").
      " (".join(", ",map {$_->Print} @{$self->Args}).")";
}

sub DebugArgs {
  my ($self,%args) = @_;
  my @refs;
  foreach my $arg (@{$self->Args}) {
    my $ref = ref $arg;
    if ($ref =~ /^$/) {
      push @refs, "ARG(".$arg.")";
    } else {
      push @refs, $ref;
    }
  }
  print Dumper(Refs => \@refs);
}

1;
